/*

     d888   8888888888     d88P 8888888888     d88P  .d8888b.  888888888
    d8888         d88P    d88P        d88P    d88P  d88P  Y88b 888
      888        d88P    d88P        d88P    d88P   888    888 888
      888       d88P    d88P        d88P    d88P    Y88b. d888 8888888b.
      888    88888888  d88P      88888888  d88P      "Y888P888      "Y88b
      888     d88P    d88P        d88P    d88P             888        888
      888    d88P    d88P        d88P    d88P       Y88b  d88P Y88b  d88P
    8888888 d88P    d88P        d88P    d88P         "Y8888P"   "Y8888P"

*/

/*** GRAF.C ***/

#define  ESC            27
#define  SetaPCima      72
#define  SetaPBaixo     80
#define  SetaPEsquerda  75
#define  SetaPDireita   77
#define  PgUp           73
#define  PgDn           81
#define  TeclaF1        59
#define  TeclaF2        60
#define  TeclaF3        61
#define  TeclaF4        62
#define  TeclaF5        63
#define  CtrlSetaPBaixo 145
#define  CtrlSetaPCima  141
#define  CtrlF1         94
#define  CtrlF2         95
#define  CtrlF3         96
#define  CtrlF4         97
#define  CtrlF5         98
#define  CtrlF6         99
#define  CtrlF7        100
#define  CtrlF8        101
#define  CtrlF9        102
#define  CtrlF10       103
#define  AltF1         104
#define  AltF2         105
#define  AltF3         106
#define  AltF4         107
#define  AltF5         108
#define  AltF6         109
#define  AltF7         110
#define  AltF8         111
#define  AltF9         112
#define  AltF10        113

float deformacao = 1, teta = M_PI/4;
int a, b, tam = 20;

/* ------------------------------------------------------------------------ */

void DesenhaPonto(float x, float y, float z) {

  float X, Y;

  X = y - x*cos(teta)/3; Y = z/deformacao - x*sin(teta)/3;
  putpixel((int) (a + X*tam), (int) (b - Y*tam), getcolor());
}

/* ------------------------------------------------------------------------ */

#define SQR(x)  ((x)*(x))

/* ------------------------------------------------------------------------ */

#define DISTANCIA(a, b, c, x, y, z) sqrt(SQR(a - x) + SQR(b - y) +SQR(c - z))

/* ------------------------------------------------------------------------ */

void DesenhaSuperficie(float (*f) (float, float), float (*g) (float, float),
	      float (*h) (float, float), float umin, float umax, float vmin,
					float vmax) {

  float X, Y, u, v, x, y, z, p1, p2, d;

  d = (vmax - vmin)/nv;
  for (v = vmin; v <= vmax + d/2.0; v += d) {
    u = umin;
    x = f(u, v); y = g(u, v); z = h(u, v);
    X = y - x*cos(teta)/3; Y = z/deformacao - x*sin(teta)/3;
    p1 = a + X*tam; p2 = b - Y*tam;
    for (u = umin; u <= umax; u += inc) {
      x = f(u, v); y = g(u, v); z = h(u, v);
      X = y - x*cos(teta)/3; Y = z/deformacao - x*sin(teta)/3;
      line((int) (a + X*tam), (int) (b - Y*tam), (int) p1, (int) p2);
      p1 = a + X*tam; p2 = b - Y*tam;
    }
    u = umax;
    x = f(u, v); y = g(u, v); z = h(u, v);
    X = y - x*cos(teta)/3; Y = z/deformacao - x*sin(teta)/3;
    line((int) (a + X*tam), (int) (b - Y*tam), (int) p1, (int) p2);
  }

  d = (umax - umin)/nu;
  for (u = umin; u <= umax + d/2.0; u += d) {
    v = vmin;
    x = f(u, v); y = g(u, v); z = h(u, v);
    X = y - x*cos(teta)/3; Y = z/deformacao - x*sin(teta)/3;
    p1 = a + X*tam; p2 = b - Y*tam;
    for (v = vmin; v <= vmax; v += inc) {
      x = f(u, v); y = g(u, v); z = h(u, v);
      X = y - x*cos(teta)/3; Y = z/deformacao - x*sin(teta)/3;
      line((int) (a + X*tam), (int) (b - Y*tam), (int) p1, (int) p2);
      p1 = a + X*tam; p2 = b - Y*tam;
    }
    v = vmax;
    x = f(u, v); y = g(u, v); z = h(u, v);
    X = y - x*cos(teta)/3; Y = z/deformacao - x*sin(teta)/3;
    line((int) (a + X*tam), (int) (b - Y*tam), (int) p1, (int) p2);
  }
}

/* ------------------------------------------------------------------------ */

void DesenhaEixos(void) {

  float inc = 0.01, i, tam_eixo = 3;

  setcolor(GREEN);
  for (i = 0; i <= 2*tam_eixo; i+= inc)
    DesenhaPonto(i, 0, 0);  /* Eixo x */
  for (i = 0; i <= tam_eixo; i+= inc) {
    DesenhaPonto(0, i, 0);  /* Eixo y */
    DesenhaPonto(0, 0, i);  /* Eixo z */
  }
}

/* ------------------------------------------------------------------------ */

/*** FIM DE GRAF.C ***/

